package java3.theories;

public class QTLists {

	 public static /*@ pure @*/ boolean QEq(int fromIndex, int toIndex, 
														 String call_a, Object a, int off_a, boolean neg_a, 
														 String call_b, Object b, int off_b, boolean neg_b)
	 {
		  if (toIndex <= fromIndex) {
				return true;
		  } else {
				java.lang.reflect.Method method_a=null, method_b=null;
				try {
					 method_a = a.getClass().getMethod(call_a, int.class);
					 method_b = b.getClass().getMethod(call_b, int.class);
				} catch (SecurityException e) {
					 System.out.println("SecurityException when trying to call: " + call_a + " or " + call_b);
				} catch (NoSuchMethodException e) {
					 System.out.println("NoSuchMethodException when trying to call: " + call_a + " or " + call_b);
				}
				java3.lang3.Integer va=null, vb=null;
				try {
					 va = (java3.lang3.Integer) 
						  method_a.invoke(a, off_a + (neg_a ? -fromIndex : fromIndex));
					 vb = (java3.lang3.Integer) 
						  method_b.invoke(b, off_b + (neg_b ? -fromIndex : fromIndex));
				} catch (IllegalArgumentException e) {
				} catch (IllegalAccessException e) {
				} catch (java.lang.reflect.InvocationTargetException e) {
				}
				return ((va == null && vb == null) || 
						  (va != null && vb != null && va.intValue() == vb.intValue())) && 
					 QEq(fromIndex + 1, toIndex, call_a, a, off_a, neg_a, call_b, b, off_b, neg_b);
		  }
	 }


	 public static /*@ pure @*/ boolean QEq(int fromIndex, int toIndex, 
														 String call_a, Object a, int off_a, boolean neg_a, 
														 java3.lang3.Integer[] b, int off_b, boolean neg_b)
	 {
		  if (toIndex <= fromIndex) {
				return true;
		  } else {
				java.lang.reflect.Method method_a=null;
				try {
					 method_a = a.getClass().getMethod(call_a, int.class);
				} catch (SecurityException e) {
					 System.out.println("SecurityException when trying to call: " + call_a);
				} catch (NoSuchMethodException e) {
					 System.out.println("NoSuchMethodException when trying to call: " + call_a);
				}
				java3.lang3.Integer va=null, vb=null;
				try {
					 va = (java3.lang3.Integer) 
						  method_a.invoke(a, off_a + (neg_a ? -fromIndex : fromIndex));
					 vb = b[off_b + (neg_b ? -fromIndex : fromIndex)];
				} catch (IllegalArgumentException e) {
				} catch (IllegalAccessException e) {
				} catch (java.lang.reflect.InvocationTargetException e) {
				}
				return ((va == null && vb == null) || 
						  (va != null && vb != null && va.intValue() == vb.intValue())) && 
					 QEq(fromIndex + 1, toIndex, call_a, a, off_a, neg_a, b, off_b, neg_b);
		  }
	 }

}
